subroutine GTDevOpen(dev, ws_id, err)
    use gtgraph_types, only: GT_DEVICE
    use netcdf_f77, only: NF_EINVAL
    use dc_error, only: StoreError
    use sysdep, only: AbortProgram
    use dcl
    type(GT_DEVICE), intent(out):: dev
    integer, intent(in), optional:: ws_id
    logical, intent(out), optional:: err
    integer, save:: opened_wsn = 0
    integer:: wsn
continue
    wsn = 3
    if (present(ws_id)) wsn = ws_id
    if (opened_wsn /= 0) then
	call StoreError(NF_EINVAL, 'GTDevOpen', cause_i=wsn)
	if (.not. present(fail)) call AbortProgram
	fail = .TRUE.
    endif
    call DclOpenGraphics(wsn)
    dev%ws_id = wsn
    opened_wsn = wsn
end subroutine

subroutine GTDevClose(dev)
    use gtgraph_types, only: GT_DEVICE
    type(GT_DEVICE), intent(inout):: dev
continue
end subroutine
